/* 
 * This is a very simple example for a dummy driver module that does
 * nothing else than giving out stupid messages to the syslog file
 *
 */

module "Simple" : /* this directive sets the global module name */

/* This stupid module consists of one global driver module 
 * you can specify a default major number here that can be overrided
 * by loading the driver with
 * /sbin/insmod Stupid.o Stupid_major=<my_major>
 */


driver "main" [ major=34 ] {

        /*
         * The main module of a driver uses the core method whenever the module
         * is loaded or unloaded to the kernel with insmod
         * the init method will be executed on load and the cleanup method on
         * unload time
         */
	core {  
		init /{ 
			printk("This is a real stupid message\n");
		}/

		cleanup /{
			printk("Have a nice day! \n");
		}/
	}
        /*
         * This method will be called whenever the driver is opened
         */
	open /{
                /* %<driver.name> */
		printk("Stupid module has been opened\n");
	}/

        /*
         * This method will be called whenever the driver is closed
         */
	close /{
		printk("Stupid module has been closed\n");
	}/

        /*
         * This method will be called on read
         */
	read /{
		printk("Stupid module read() called\n");
	}/
        

        /*
         * This method will be called by calling the ioctl() function
         *
         * within the ioctl method different submethods can be specified
         * the 'func' method for example expands automatically to the
         * desired library function with the same name and call convention
         *
         */
	ioctl {
             /* from the library this method is simply called with 
              * SetMode( flags );
              */
	     func SetMode (int flags) /{
		printk("Stupid Mode flags is %d",flags);
	     }/

        }
}

